// application: Job Listings Center        
//     version: 1.0b (beta of 8/13/96)   
//    fileName: Functions.js             
// description: This file comtains the definitions of most functions used by the 
//              Job listings Center
//     company: Austin-Hayne Corporation.  (415) 655-3800                    
//              2000 Alameda de las Pulgas, Suite 242, San Mateo, CA 94403  
//     history: Created by ggh.  First released 7/22/96 
//              Major revision 8/3/96.  
//                        added include() function
//                        moved all client-side function definitions to .inc files. 
//              8/10/96: Had to remove the include fiels, but kept the function.
//                       (The server-side file I/O made the system unstable) 
//              8/11/96: Verify
//              8/12/96: mkd & ggh includeDecode & includeVerify includeDates
//---------------------------------------------------------------------------------------------

/*            **********************************************************
              *  ATTENTION: To run the Job Center, you will need to    *  <--READ THIS
              *             change the definition of dbConnect to      *
              *             use the correct password, etc, for your    *
              *             DBMS system                                *
              **********************************************************
*/


/*-----------------------------------------------------------
  This function creates the HTML for a sequence of data 
  entry/edit boxes for editing the fields in the global 
  fields ojbect.  The function iterates over the individual
  fields within the fields object, and calls the makeEditBox
  method for each individual field.  Different kinds of
  fields have different makeEditBox methods.
  -----------------------------------------------------------*/

function buildDataEntryTable(){                        //trace  write("<BR>Start buildDataEntryTable");

              write("<TABLE Border=0>");
              for (j=1; j<=fields.lengthEditable; j++){
                  fields[j].makeEditBox();
              };  
              write("</TABLE>");
};


/*-----------------------------------------------------------
  bindStandard is the standard method for binding a database field
  to its current value when building a SQL command to do an 
  UPDATE or INSERT.
  -----------------------------------------------------------*/

function bindStandard() {
           var str = (this.autoValue==null) ? eval("request."+this.name) : this.autoValue;
           if (str=="") {str="null"};
           str=encode(str);                          
           if (str!="null" && this.quoteValues==true){str=Q+str+Q};
           cols=cols+leader+this.name;
           vals=vals+leader+str;
           bindings=bindings+leader+this.name+"="+str;
           leader=", ";
};




                           
/*-----------------------------------------------------------
  bindText is the method used to bind a text field to its value
  for purposes of a SQL UPDATE or INSERT.  Because of limitations
  with the Informix DBMS implementation of the TEXT datatype,
  long values are broken up into a number of varChar(255) fields.
  Breaks are made at word boundries to support the spotting of
  keywords during keyword searches.  A logical text field such as
  dlong (the long description of a job) is split into fiels with
  names adding digits to the root, as in dlong1, dlong2, etc.
  -----------------------------------------------------------*/

function bindText(){
           var str="";
           var low=0;
           var high=254;
           var encoded=encode(eval("request."+this.name))+" ";    // need trailing space to find end of string;  
                                                                  // write("<br>ENCODED:"+encoded);flush();
           for (var i=1; i<=this.subfieldCount; i++){             // write("<BR>I="+i);flush();
             if (high>encoded.length){high=encoded.length};       // write("<BR>higha="+high);flush();
             if (high>0){high=encoded.lastIndexOf(" ", high)};    // write("<BR>highb="+high);flush();
             if (high>low){                                       // write("<BR>highc="+high);flush();
               str=encoded.substring(low, high);
               low=high;
             } else {                                             // write("<BR>highd="+high);flush();
               str="";
             };
             high=high+254;
             str = (str=="") ? "null" : Q+str+Q;                  // write("<BR>str="+str);flush();
             cols=cols+leader+this.name+i;
             vals=vals+leader+str;
             bindings=bindings+leader+this.name+i+"="+str;
             leader=", ";
           };
};




/*-----------------------------------------------------------
  Function bindVariables produces bindings for all fields encapsulated
  in the current fields object.  These bindings are used in the
  specification of SQL commands for UPDATE or INSERT.
  -----------------------------------------------------------*/

function bindVariables(){             
            cols="";
            vals="";
            bindings="";
            leader=" ";
            for (j=1; j<=fields.lengthBindable; j++){         //write("<br>BINDING:"+fields[j].name);
                  fields[j].bind();
            };
};





/*-----------------------------------------------------------
  ComputeOptions computes the data needed for function GetOptions, 
  which creates an HTML select object that allows users
  to select a value from a list.  The list represents all current
  values for a given field field in a given DBMS table.  The CurrentOptions
  function finds all the values for a given field and places then
  in a global parameter whose name has the structure
         project.fieldOptions  
  as in  project.departmentOptions.  We don't want to have to
  compute these options, so they are kept in a string with
  individual options separated by "|" characters.  
  -----------------------------------------------------------*/

function ComputeOptions(field, table){     
          var list="";
          var i=0;
          cursor = database.cursor("SELECT DISTINCT " + field + " FROM " + table + " ORDER BY " + field);
                                              
          while (cursor.next()){
            list=list+eval("cursor." + field)+"|";
          };
          eval("project." + field + "Options=list");
                                             
};


/*-----------------------------------------------------------
  GetOptions creates an HTML select object that allows users
  to select a value from a list.  The list represents all current
  values for a given field field in a given DBMS table.  This
  function uses data supplied by the ComputeOptions function.
  ComputeOptions gets the data from the DBMS and holds on to
  it for a long time--until something changes in the DBMS that
  might render the info out of date.  Each time the client needs
  an option list, GetOptions is called and builds the options 
  from the string created by ComputeOptions.  However, in creating
  the HTML, GetOptions indicates the what value the current user
  selected for this field last time.  That way, the most recent
  choice is preselected.
  -----------------------------------------------------------*/

function GetOptions(field){              //write("<br>GET OPTIONS FOR "+field); flush();
           var low=0;
           var high=0;
           var current="";
           var result="";
           var max=0;
           var foundSelected=false;                            //write("<br>Checker 1");flush();


           var optionList=eval("project."+field+"Options");    //write("<br>Checker 2");flush();
           var selected=eval("client."+field);                 //write("<br>Checker 3");flush();
           if (optionList==null){optionList=""};
           max=optionList.length-1;
           if (selected==null){selected="All"};               //write("<br>SELECTED:"+selected);flush();
           high=optionList.indexOf("|", low);                  //write("<br>Checker 4");flush();
           while (high==null && high>low){
             current=optionList.substring(low, high);          //write("<br>current:"+current);flush();
             if (current==selected){
                 result=result+"<OPTION SELECTED>"+current;
                 foundSelected=true;
             } else {
                 result=result+"<OPTION>"+current;
             };
             if (high>=max){break};
             low=high+1;
             high=optionList.indexOf("|", low);
                                                              //if (high==null){ write("<BR>NULL!!!!!");};     
                                                              //write("<br>low/high:"+low+"/"+high);flush();
           };
                                                              //write("<br>Checker 5");flush();
           if (foundSelected==true){                          //write("<br>Found Selected");flush();
             return("<OPTION>All"+result);
           } else {                                          //write("<br>No Found Selected");flush();
             return("<OPTION SELECTED>All"+result);
           };
};





/*-----------------------------------------------------------
  Converts data objects to strings in the format mm/dd/yyyy.
  Yes Virginia, this will work even after 1999: d.getYear()
  returns the number of years since 1970.
  -----------------------------------------------------------*/

function dateToString(dIn) {
               var d=new Date();
               d=dIn;
               return((d.getMonth()+1)+ "/" 
                      +d.getDate()    + "/" 
                     +(d.getYear()+1900));
};




/*-----------------------------------------------------------
  dbConnect is used in HTML pages at the point where the user
  needs access to the DBMS.  Two things are noteworthy here.
  First, if the connection fails, the system puts up a message
  and flushes the page.  (HaltOperations is an undefined
  function, and attempting to execute it creates a failure.  But
  the user never sees it.)
  Second, there are two (or more) different strategies for
  connecting to a DB.  (A) connect when the user first asks for
  anything and just hang on to the connection.  This is fast and 
  simple, but it burns up DB connections, which may be in short
  supply on some systems.  (B) disconnect immediately after each
  DB operation, keeping any necessary state information in
  variables local to the project or specific client.  This method
  is much better on cutting down on the number of connections
  used,  but slows down the system since making a connection can
  take several seconds.
  This application is designed to do it either way.  Just change
  the project.holdConnection parameter initialized in Initial.html.  
  -----------------------------------------------------------*/

function dbConnect(){
          if (project.holdConnection!="true"){  
            database.connect("INFORMIX","netscape_godzilla","informix","informix","jobcenter");    
          }  // else we should already be connected.
          if (database.connected()!=true){
            write("<h1>Sorry, the database is currently unavailable.</h1>");
            flush();
            HaltOperations;
          } else {
            return true;
          };
};



/*-----------------------------------------------------------
  Companion program to dbConnect.
  -----------------------------------------------------------*/

function dbDisconnect(){
          if (project.holdConnection!="true"){
            database.disconnect()
          }  // else, we should hold the connection open by doing nothing
};






/*-----------------------------------------------------------
  The encode function converts a string as might be displayed 
  to a user into a string that can be saved in the informix
  DBMS using their SQL functions.  The SQL functions are sensitive
  to quotes (single or double) and semicolons.  CR and LF are
  not allowed in informix varChar fields.
  Why not just use the escape and unescape functions provided
  with javascript?  Because different versions of these functions
  are used on the server than on the client!  If you unescape
  something on the client, you don't get back what was escaped
  on the server.  Hence, we have to roll our own here.
  See functions decode and includeDecode.
  -----------------------------------------------------------*/

function encode (str) {
          var newStr ="";
          var max=str.length;
          for (var i=0; i<max; i++){
            next=str.charAt(i);
            if      (next=="\"") {newStr=newStr+"@D"}
            else if (next=="\'") {newStr=newStr+"@S"}
            else if (next=="@" ) {newStr=newStr+"@A"}
            else if (next==";" ) {newStr=newStr+"@c"}
            else if (next==CR)   {newStr=newStr+"@L"; i++}
            else {newStr=newStr+next
            };
          };
          return newStr;
};




/*-----------------------------------------------------------
  extendWhere is used to extend the WHERE clause of an SQL
  statement to include an equality constraint on the field
  passed in as a parameter.
  -----------------------------------------------------------*/

function extendWhere(field){
            var fvalue=eval("request."+field);
            if (fvalue!="All" && fvalue!=null && fvalue!="null" && fvalue!=""){
              if (whereClause!=""){
                 whereClause= whereClause + " AND "
              };
              whereClause = whereClause + field + " = " + Q + fvalue + Q
            };
};






/*-----------------------------------------------------------
  Function extendWhereKW is used to extend the WHERE clause of an SQL
  statement to include a keyword search on the 'field'
  passed in as a parameter.
  This function searches for key words by using the Informix MATCHES operator.
  Upper and lower case are allowed by using [] as in [Cc][Aa][Tt] for cat.
  In other DBMS, use the LIKE operator, the ANSI standard.
  Informix supports LIKE, but it is case sensitive.  The MATCHES operator provides
  a way to deal with case.  Also, some other DBMS allow searches (LIKE) on the TEXT
  datatype.  Informix does not.  This is why the large fields are 
  split up into multiple varChars.  Otherwise, they would not be searchable.
  This function searches for a logical field by looking across multiple
  actual fields by using OR constructions.  For example,  when looking for
  'duties',  the system will look for 'duties' at any of the four previous
  employers.  Moreover,  each of the duties (duties1, duties2, duties3 and duties4)
  is divided into multiple varchars.  So a search on duties will actually
  do an OR of searches over 40 fields, with each of the four duties broken
  into 10 subfields.
  -----------------------------------------------------------*/

function extendWhereKW(field, fieldCount, textFlag){                      //trace write("<br>KEY FOR: "+field);flush();
            var fvalue = eval("request."+field);
            var pattern="";
            var term   = "(";
            var leader = "";
            var OP=" MATCHES ";        // ANSI alternative is " LIKE "
            var WildCard="*";          // ANSI alternative is "\%"
            var i=0;
            var j=0;
            if (fvalue!=null && fvalue!="" && fvalue!="null"){
              if (whereClause!=""){
                 whereClause= whereClause + " AND "
              };
              fvalue=encode(fvalue);
              for  (i=0;  i<fvalue.length; i++){
                pattern = pattern + "[" + fvalue.charAt(i).toUpperCase() + fvalue.charAt(i).toLowerCase() + "]";
              };
              pattern= Q +WildCard+ pattern + WildCard + Q;
              if (textFlag!=true){
                 for (i=1; i<=fieldCount; i++){
                   term = term + leader + field + i + OP + pattern;
                   leader=" OR ";
                 };
              } else {                                                     //write("<br>TEXT FIELD CASE");flush();
                 var max = fields.fieldByName(field+"1").subfieldCount;    // The +"1" gets a real name of a text field from the root.
                 for (i=1; i<=fieldCount; i++){                            //write("<br>Ik="+i+":"+k);flush();
                   for (j=1; j<=max; j++){
                      term = term + leader + field + i +""+ j + OP + pattern;
                      leader=" OR ";
                   };
                 };
              };
              term=term + ")"; 
              whereClause = whereClause + term;                             //write("<br>EXIT KEY FUNCTION");flush();
            };
};





/*-----------------------------------------------------------
  Returns the DECODED value of a field.  Similar to cursor.field.
  -----------------------------------------------------------*/

function fetchV(fieldName){
  return decode(fields.fieldByName(fieldName).init());
};




/*-----------------------------------------------------------
  Writes the DECODED value of a field.
  -----------------------------------------------------------*/

function fetchW(fieldName){
  write(decode(fields.fieldByName(fieldName).init()));
};




/*-----------------------------------------------------------
  function Field is the creator function for field objects.
  These objects are automatically incorporated into the structure 
  of the fields object.  (Do not confuse field objects with fields 
  objects)
  A field object has
     properties
       name:         the field name as used in the DBMS
       quoteValues:    indicates whether the values of the field must be
                     quoted when incorporated in SQL statements.  String
                       fields are quoted, integer fields are not.
       label:        default label to be used on date entry boxes.
       displayWidth: default width for data entry boxes displaying the field.
       -------------some field objects have these additional properties ------
       autoValue:     Value to be inserted on UPDATE or INSERT rather than the
                        value taken from a field's edit box.  used for serial numbers,
                        and time stamps.
       subfieldCount: For logical text fields, specifies the number of subfields
                        into which the values are to be split.
       rows:         Number of rows to display in multi-line edit box.
       cols:         Number of columns to display in multi-line edit box.

     methods
       makeEditBox(): method for creating an edit box for displaying/
                       editing the field.
       init():       method for getting an initial value for the field.
       bind():       method for binding the value of the field when creating 
                       an SQL statement
  -----------------------------------------------------------*/

function Field(name, quoteValues, displayWidth, label){   //write("<BR>FIELD:"+name+fields.length);
           fields.length=fields.length+1; 
           fields[fields.length]=this;     
           this.name=name;
           this.quoteValues=quoteValues;
           this.label=label;                          
           this.displayWidth=displayWidth;         
           this.makeEditBox = makeStandardEBox;
           this.init = getInitialValue;
           this.bind = bindStandard;
           return this;
};



/*-----------------------------------------------------------
  Method fieldByName returns a field object, given a field name.
  A method of the fields object.
  -----------------------------------------------------------*/

function fieldByName(name){                      // write("FieldByName:"+name+"  length=" + this.length);
       for (var i=1; i<=this.length; i++){
         if (this[i].name==name) {return this[i]};
       };
       return null;
};





/*-----------------------------------------------------------
  function FieldsList is used to create fields objects.  (Field
  objects--with no s--are discussed above.
  A fields object captures information about all the fields for
  a particular table.  In particular fields[i] is the i-th field
  object of the table.
  Note that the function provides a sort of meta table of field
  information.  Encapsulated here is all the schema information 
  about the Job Listings Center database.
  properties
    length: number of fields in data set.
    lengthEditable: Max number of field-object index for fields that
                    can be edited by users.  Users cannot edit fields
                    recording time stamps and serial numbers.
    lengthBindable: Max number of field-object indes for fields that
                    must be bound in creating SQL UPDATE and INSERT 
                    statements.  Not all fields are bound.  For example
                    record creation time stamp is never set under
                    program control, but is managed by rules in the DBMS.
    i:      fields[i] is the i-th field OBJECT of the dataset.
    keyField: The name of the keyField for the dataset.  This is a string,
              not a field object.
  methods:
     there are no methods.  However, the functions bindVariables
     and buildDataEntryTable probably should be converted to methods of
     this class.
  -----------------------------------------------------------*/

function FieldsList(table){  
        var field;          
        var lengthEditable;
        var lengthBindable;                   
        fields=this;                          
        this.length=0;
        table=table.toUpperCase();
        if (table=="JOB"){

//                 ___NAME_____  QUOTES WIDTH _____LABEL________
        new Field("req",          true,  20, "Requisition Number"           );
        new Field("department",   true,  30, "Department"                   );
        new Field("title",        true,  50, "Title"                        );
        new Field("hiringmgr",    true,  50, "Hiring Manager"               );
        new Field("hmemaddress",  true,  50, "Hiring Manager e-mail address");
        new Field("jobgrade",     true,  10, "Job Grade"                    );
        new Field("jobtype",      true,  10, "Job Type"                     );
        new Field("jstatus",      true,  10, "Job Status"                   );
        new Field("image",        true,  10, "Splash Image"                 );
        new Field("needed",       true,  10, "When Needed (mm/dd/yyyy)"     );
        new Field("numopen",      false,  5, "Number Open"                  );
        new Field("recruiter",    true,  30, "Recruiter"                    );
        new Field("reqtype",      true,  10, "Req Type"                     );
        new Field("salarylow",    false, 10, "Salary Low"                   );
        new Field("salaryhigh",   false, 10, "Salary High"                  );
        new Field("site",         true,  50, "Site Name"                    );
        new Field("siteaddress1", true,  80, "Site Address1"                );
        new Field("siteaddress2", true,  80, "Site Address2"                );
        new Field("sitecity",     true,  50, "Site City"                    );
        new Field("sitestate",    true,   3, "Site State"                   );
        new Field("sitezip",      true,  12, "Site Zipcode"                 );
        new Field("dshort",       true, 100, "Short Job Description"        );
        new Field("dlong",        true,   0, "Full Job Description"         );
        new Field("mgrnote",      true,   0, "Note from Hiring Manager"     );
        lengthEditable=this.length;
        lengthBindable=this.length;
        new Field("jid",          false,  0, "Internal Serial Number"       );
        new Field("tedit",        false,  0, "Last Edited"                  );
        new Field("tcreated",     false,  0, "Time Created"                 );

        this.lengthEditable=lengthEditable;
        this.lengthBindable=lengthBindable;

        this.fieldByName=fieldByName;

        fields.fieldByName("needed").init=getInitialDate;

        fields.fieldByName("tedit").autoValue="CURRENT YEAR TO SECOND";

        textField("dlong").subfieldCount=10;
        textField("mgrnote").subfieldCount=4;

        this.keyField="jid";   

        } else {
        if (table=="APPLICATION"){
//                 ___NAME_____  QUOTES WIDTH _____LABEL________
        new Field("additional",  true,    0, ""           ); // additional text about applicant
        new Field("address1",    true,   50, ""           );
        new Field("address2",    true,   50, ""           );
        new Field("city1",       true,   50, ""           );
        new Field("city2",       true,   50, ""           );
        new Field("degree1",     true,   50, ""           );
        new Field("degree2",     true,   50, ""           );
        new Field("degree3",     true,   50, ""           );
        new Field("degree4",     true,   50, ""           );
        new Field("duties1",     true,    0, ""           ); // text fields for duties at employer
        new Field("duties2",     true,    0, ""           );
        new Field("duties3",     true,    0, ""           );
        new Field("duties4",     true,    0, ""           );
        new Field("employer1",   true,   50, ""           ); // Most recent employers
        new Field("employer2",   true,   50, ""           );
        new Field("employer3",   true,   50, ""           );
        new Field("employer4",   true,   50, ""           );
        new Field("from1",       true,   10, ""           ); // employed from date
        new Field("from2",       true,   10, ""           );
        new Field("from3",       true,   10, ""           );
        new Field("from4",       true,   10, ""           );
        new Field("gpa1",        true,    4, ""           );  // grade point average
        new Field("gpa2",        true,    4, ""           );
        new Field("gpa3",        true,    4, ""           );
        new Field("gpa4",        true,    4, ""           );
        new Field("gradyear1",   true,    4, ""           ); // graduation year
        new Field("gradyear2",   true,    4, ""           );
        new Field("gradyear3",   true,    4, ""           );
        new Field("gradyear4",   true,    4, ""           );
        new Field("jobtitle1",   true,   50, ""           ); // titles of previous jobs
        new Field("jobtitle2",   true,   50, ""           );
        new Field("jobtitle3",   true,   50, ""           );
        new Field("jobtitle4",   true,   50, ""           );
        new Field("major1",      true,   50, ""           ); // school majors
        new Field("major2",      true,   50, ""           );
        new Field("major3",      true,   50, ""           );
        new Field("major4",      true,   50, ""           );
        new Field("objective",   true,    0, ""           ); // text area
        new Field("phone1",      true,   20, ""           );
        new Field("phone2",      true,   20, ""           );
        new Field("phone3",      true,   20, ""           );
        new Field("reseaddress", true,   50, ""           ); // email address
        new Field("resemailok",  true,    3, ""           ); // is it ok to send e-mail
        new Field("resname",     true,   50, ""           ); // applicant name
        new Field("school1",     true,   30, ""           );
        new Field("school2",     true,   30, ""           );
        new Field("school3",     true,   30, ""           );
        new Field("school4",     true,   30, ""           );
        new Field("state1",      true,    2, ""           );
        new Field("state2",      true,    2, ""           );
        new Field("to1",         true,   10, ""           );
        new Field("to2",         true,   10, ""           );
        new Field("to3",         true,   10, ""           );
        new Field("to4",         true,   10, ""           );
        new Field("zip1",        true,   12, ""           );
        new Field("zip2",        true,   12, ""           );

        new Field("resdep",      true,   50, ""           ); // department applied to
        new Field("reshrmgr",    true,   50, ""           ); // Hiring manager of posting
        new Field("ressite",     true,   50, ""           ); // site applied to
        new Field("restitle",    true,   50, ""           ); // title of job applied for
        new Field("resreq",      true,   20, ""           ); // req num of job applied for
        new Field("resjid",      false,   0, ""           ); // num of job applied for

        lengthEditable=this.length;
        lengthBindable=this.length;

        new Field("resid",       false,   0, ""           ); // internal serial number
        new Field("rescreated",  false,   0, ""           ); // resume creation time

        this.lengthEditable=lengthEditable;
        this.lengthBindable=lengthBindable;

        this.fieldByName=fieldByName;

        textField("additional");
        textField("duties1");
        textField("duties2");
        textField("duties3");
        textField("duties4");
        textField("objective");  

        this.keyField="resid";  

        }else{write("<BR><b>Error.  Unknown table="+table+".  Use all caps?");
        };
        };
};





/*-----------------------------------------------------------
  This function is used to display a standard footer at the
  end of most pages in the Job Listings Center.  Putting it
  here keeps us from having to copy it into every page.
  -----------------------------------------------------------*/

function footer(){
          write("<TABLE width="+project.pageWidth+" cellspacing=0 cellpadding=0>"       // outter table
               +"<TR><TD></TD><TD align=right valign=top>"                      
               +       project.buttonBack + project.buttonSeparator + project.buttonHome
               +"</TD></TR>"
               +"<TR><TD>" 

               +"<TABLE border=0 cellpadding=0><TR><TD>"             // bottom left table (company data)
               +"<a href='mailto:jccomments@austin-hayne.com'>"
               +"<font size=2>________________________________<br>"
               +"Comments: jccomments@austin-hayne.com</font></a>"
               +"<ADDRESS>"
               +"<font size=1><br>"
               +"Created by <b>Austin-Hayne</b> Corporation <BR>"
               +"2000 Alameda de las Pulgas<BR>"
               +"Suite 242<BR>"
               +"San Mateo, CA  94403<br>"
               +"(800) 809-9920"
               +"</ADDRESS>"
               +"<font size=1>"+dateToString(new Date())+"</font>"
               +"</TD></TR></TABLE>"                                 // end bottom left table

               +"</TD>"   
               +"<TD align=right valign=bottom>"                     // lower-right cell for AH reference
               +"<A href='http://www.austin-hayne.com/appalanche.html'>"
               +"<font size=2>Visit Austin-Hayne, creator of the Job Listings Center</font></A>"
               +"</TD></TR>"             
               +"</TABLE>"                                 // end outter table
         );
};




/*-----------------------------------------------------------
  getInitialData is a method of date-field objects.  It returns
  the initial value of a database field.  On an ADD operation,
  the fields initially have a emply value.  Otherwise, it
  converts from the date object to a string representing the 
  date.
  -----------------------------------------------------------*/

function getInitialDate() {
       var dbVal;
       if (request.mode=="add"){return ""}
       else {dbVal=eval("cursor."+this.name);
             if (dbVal==null){return ""}
             else {return dateToString(dbVal)
             };
       };      
};
   



/*-----------------------------------------------------------
  getInitialText is a method of text-field objects.  These types
  of fields are actually stored in multiple varChar fields.  It
  was not possible to use the informix TEXT datatype in this
  application because of the need to do keyword searches on
  field data.
  The method extracts info from the various fields in the DBMS
  that hold related information, concatenates them into a string.
  -----------------------------------------------------------*/

function getInitialText(){
       var result="";
       var str;
       if (request.mode=="add"){return ""};
       for (var i=1; i<=this.subfieldCount; i++){
         str=""+eval("cursor."+this.name+i);
         if (str=="null"){str=""; return result};
         result=result+str;
       };
       return result;
};





/*-----------------------------------------------------------
  method for getting the initial value of ordinary field objects.
  -----------------------------------------------------------*/

function getInitialValue(){
       var str="";
       if (request.mode!="add"){
           str=""+eval("cursor."+this.name);
           if (str=="null"){str=""};
       };
       return(str);
};


/*-----------------------------------------------------------
  Function header is used to create a standard HTML header and
  banner for most web pages of the Job Listings Center. It also
  1) creates and initializes several local variables for use on the page.
  2) calls includeDecode(), which includes certain javascript function
     definitions in the HTML file for use on the client side.
     Chief among these is the decode function, which is used
     in displaying data taken from the DBMS.
  -----------------------------------------------------------*/

function header(subTitle, headerHTMLSequence, onLoad){
      write("<HTML><HEAD><TITLE>Job Listings Center: "
            + subTitle + "</TITLE></HEAD>");
                                     
      // initialize 'local' variables used on most pages.
      eval("Q =unescape('%22')"); // "
      eval("SQ=unescape('%27')"); // '
      eval("CR=unescape('%0D')"); 
      eval("LF=unescape('%0A')"); 
      eval("CRLF=unescape('%0D%0A')");
      
      // put in javascript for decoding data from DBMS.  this lets
      // users have quotes and other marks in fields.
      includeDecode();
      write("<BODY BGCOLOR=" +Q+ project.bodyColor +Q+ ">");
      if (headerHTMLSequence.length>0){
          write("<TABLE border=0 width=" + project.pageWidth + "><TR><TD>" 
                  + headerHTMLSequence
                  + "</TD><TD align=right valign=top>" 
                  + "<font size=1 color=#000066><B>"
                  + dateToString(new Date())
                  + "</B></font></TD></TR></TABLE>");
      };

};


/*-----------------------------------------------------------
  header2 is used to draw the area just below the header which 
  contains buttons and text describing the page.
  -----------------------------------------------------------*/
function header2(majorText, minorText, button1, button2, button3, button4){
   write("<TABLE width=project.headerWidth border=0 cellpadding=0 cellspacing=0>"
      + " <TR><TD align=left valign=top width=345>"  //##### get rid of constant width
      + "<Font size=5>"
      + majorText
      + "</font>");
   if (minorText.length>0){
      write("<br><font size=4>" + minorText + "</font>");
   };
   write("</TD><TD align=right valign=top width=132>"); //##### get rid of constant width
   if (button1!=null && button1.length>0){write(        button1)};
   if (button2!=null && button2.length>0){write("<BR>" + button2)};
   if (button3!=null && button3.length>0){write("<BR>" + button3)};
   if (button4!=null && button4.length>0){write("<BR>" + button4)};
   write("</TD></TR></TABLE>");
};



/*-----------------------------------------------------------
  Function include is used to fetch a code segment from a text
  file and insert it into an HTML file that is being composed.
  The purpose of include is to let just one source file
  define a given piece of code which may be needed by
  several HTML files. 
  Include files must contain the strings ***BEGIN*** and ***END***.
  Everything in the file between the ***BEGIN*** and ***END***
  is included in the HTML.  Everything else is comment.
  -----------------------------------------------------------

******************* REMOVED BECAUSE OF A BUG IN JAVASCRIPT FILE I/O ************

function include(fileName){
  var file=new File(project.pathToIncludes+fileName);
  var length=0;
  var string="";
  if (file.open("r")){
      length=file.getLength();  
      string=file.read(length);   
      file.close();  
      length=string.indexOf("***END***");  
      string=string.substring(string.indexOf("***BEGIN***")+11,length);
      write(string);                  
  } else {
    //file did not open properly.
    string="ERROR IN OPENING FILE: " + fileName;
    write(string);
    flush();
    file.close();
  }
};

*/

/*-----------------------------------------------------------
  makeParagraphEBox is the makeEditBox method of text field objects.
  It writes the HTML needed to create an edit box for displaying
  and editing the fields data.  For text fields, this is a
  multi line area based on the TEXTAREA construct.
  -----------------------------------------------------------*/

function makeParagraphEBox(){                                 
  write("<tr><td colspan=2><br>"+this.label+":<br>"
      + "<TEXTAREA wrap=virtual NAME="+Q+this.name+Q+"ROWS="+this.rows+" COLS="+this.cols+">"
                            +this.init()+ "</TEXTAREA></td></tr>");
};



/*-----------------------------------------------------------
  makeStandardEBox is the makeEditBox method of most field objects.
  It writes the HTML needed to create an edit box for displaying
  and editing the fieldss data.  This is a single-line text
  entry area.
  -----------------------------------------------------------*/

function makeStandardEBox(){ 
  var label=this.label;
  var field=this.name; 
  var size =this.displayWidth;
  var str = this.init();
  str = (str=="" || str==null) ? "" : " VALUE="+Q+str+Q;
  write("<tr><td valign=bottom>"+label+":</td>"
      + "<td valign=bottom><INPUT TYPE="+Q+"TEXT"+Q+" NAME="+Q+field+Q
                            + str
                            + " SIZE="+Math.min(40,size)+"></td></tr>");
};



/*-----------------------------------------------------------
  Creation method for creating an empty object.  Properties can
  be added later.
  -----------------------------------------------------------*/

function Object(){return this
};



/*-----------------------------------------------------------
  Function saveWrite is used as an alternative to the write
  function.  The productions of some HTML pages is expensive,
  requiring heavy hits on the DBMS.  If the same page is likely
  to be asked for multiple times (by many users), the saveWrite
  can be used in the creation of the page.  A copy of the 
  page is saved in a string.  The next time the system needs
  to generate the page (or a larger page for which the saved
  'page' is only a part), we can just output the string rather
  than hit the DB.  See JobQuery.html for use.
  -----------------------------------------------------------*/

function saveWrite(string){
             page=page+string;
             write(string);
};





/*-----------------------------------------------------------
  This function is used to convert a standard field object to
  a text field object.  The function is passed the name of the
  field.  It finds the associated field object and sets (or resets)
  various properties and methods.
  -----------------------------------------------------------*/

function textField (name) {
              var field=fields.fieldByName(name);
              field.subfieldCount=10;
              field.rows=5;
              field.cols=70;
              field.init=getInitialText;
              field.makeEditBox=makeParagraphEBox;
              field.bind=bindText;
              return field;
};



/*-----------------------------------------------------------
  Function for decoding encoded strings.  See explanation for
  encode.  This function runs on the server side.  An identical
  function runs on the client side.  See includeDecode.
  -----------------------------------------------------------*/

function decode (str) {
          var newStr ="";
          var next ="";
          var CRLF=unescape("%0D%0A");
          var max=str.length;
          for (var i=0; i<max; i++){
            next=str.charAt(i);
            if (next!="@") {newStr=newStr+next}
            else {
              i++;
              next=str.charAt(i);
              if      (next=="D") {newStr=newStr+"\""}
              else if (next=="S") {newStr=newStr+"\'"}
              else if (next=="A") {newStr=newStr+"@"}
              else if (next=="c") {newStr=newStr+";"}
              else if (next=="L") {newStr=newStr+CRLF}  
              else {newStr=newStr+"ERROR IN DECODER"
              };
            };
          };
          return newStr;
};




function showPick( name, vals )
{
  var data = "";
  var args = showPick.arguments;
  if ( args.length == 3 )
  {
    data = args[ 2 ];
  }
  write( "<select name=\"" + name + "\">" );
  var pick = data == "";
  while ( vals != "" )
  {
    var term = vals.indexOf( "/", 0 );
    if ( term == -1 )
      term = vals.length;
    var first = vals.substring( 0, term );
    if ( term == vals.length )
      vals = ""
    else
      vals = vals.substring( term + 1, vals.length );
    if ( pick || data == first )
    {
      write( "<option selected>" + first );
      pick = false;
    }
    else
    {
      write( "<option>" + first ); 
    }
  }
  write( "</select>" );
}




//----------------------------------------------------------------
// -------------  Global Variable Initialization -----------------

//       See file Initial.html for variable initialization.


// INCLUDE FUNCTIONS --
// have these because include doesn't work

//______________________________________________________________________
// includeDecode() writes functions needed on the client side for
// decoding long text fields that may contain troublesome characters for
// HTML or SQL such as quotes, carriageReturn LineFeed, etc.
//______________________________________________________________________

function includeDecode(){

write(  '<SCRIPT LANGUAGE=JavaScript>'                            );

write(  'function cancel (form) { history.back() };'              );

write(  'CRLF=unescape("%0D%0A");'                                );

write(  'function decode (str) {'                                 );
write(    'var newStr ="";'                                       );
write(    'var max=str.length;'                                   );
write(    'for (var i=0; i<max; i++){'                            );
write(              'next=str.charAt(i);'                         );
write(              'if (next!="@") {newStr=newStr+next}'         );
write(              'else {'                                      );
write(                'i++;'                                      );
write(                'next=str.charAt(i);'                       );
write(                'if      (next=="D") {newStr=newStr+"\\\""}'  );
write(                'else if (next=="S") {newStr=newStr+"\\\'"}'  );
write(                'else if (next=="A") {newStr=newStr+"@"}'   );
write(                'else if (next=="c") {newStr=newStr+";"}'   );
write(                'else if (next=="L") {newStr=newStr+CRLF}'  );
write(                'else {newStr=newStr+"ERROR IN DECODER"'    );    
write(                '};'                                        );
write(              '};'                                          );
write(            '};'                                            );
write(            'return newStr;'                                );
write(  '};'                                                      );



write(  'function decodeAll(form){ '                                                 );
write(              'for (var i=0; i<form.elements.length; i++) {'                   );
write(                'if (form.elements[i].value!=null){'                           );
write(                    'form.elements[i].value = decode(form.elements[i].value)'  ); 
write(                '};'            );
write(              '};'              );
write(  '}; '                         );

write(  '</SCRIPT>'                   );

};

//___________________________________________________________________________________

function includeVerify(){
write(  '<SCRIPT LANGUAGE="JavaScript">               ');

write(  'alertInProgress=false;                       ');

write(  'function alertOnNull(field){                 ');
write(  '  if ( ! alertInProgress){                   ');
write(  '     if (! hasData(field)){                  ');
write(  '        alertInProgress=true;                ');
write(  '        alert("This field ("+ field.name +") should not be left blank"); ');
write(  '        alertInProgress=false;               ');
write(  '     }                                       ');
write(  '  };                                         ');
write(  '};                                           ');

write(  'function hasData(field){                     ');
write(  '  if (field.value.length > 0)                ');
write(  '  {       return true                        ');
write(  '  } else {return false                       ');
write(  '  };                                         ');
write(  '};                                           ');

write(  'function fldByName(fieldName, form){         '); // Needed because of a bug in javascript.
write(  '  for (var i=0; i<form.length; i++){         '); // form.fieldName does not find the field
write(  '    if (form.elements[i].name==fieldName){   '); // if it contains an onBlur event handler.
write(  '       return form.elements[i];              ');
write(  '    };                                       ');
write(  '  };                                         ');
write(  '  return null;                               ');
write(  '};                                           ');

write(  'function isEmailOK(field){                   ');
write(  '  if (!hasData(field)) return true;          ');
write(  '  if (field.value.indexOf("@") == -1)        ');
write(  '  {                                          ');
write(  '    alert("Email address must contain an @");');
write(  '    return false;                            ');
write(  '  }                                          ');
write(  '  return true;                               ');
write(  '};                                           ');

write(  'function fldNumByName(fieldName, form){      '); 
write(  '  for (var i=0; i<form.length; i++){         ');    
write(  '    if (form.elements[i].name==fieldName){   ');  
write(  '       return i;                             ');
write(  '    };                                       ');
write(  '  };                                         ');
write(  '  return null;                               ');
write(  '};                                           ');

write(  '</SCRIPT>                                    ');

};



function includeDates()
{
write( "<script>")
write( "function daysInMonth( month, year )")
write( "{")
write( "     dim = 31;")
write( "     // Thirty days hath September...")
write( "     if ( month == 9 || month == 4 || month == 6 || month == 11 )")
write( "       dim = 30;")
write( "     else if ( month == 2 )")
write( "     {")
write( "       dim = 28;")
write( "       if ( year % 4 == 0 )")
write( "         dim += 1;")
write( "       if ( year % 100 == 0 && year % 400 != 0 )")
write( "         dim -= 1;")
write( "     }")
write( "     return dim;")
write( "}")

write( "function isPosInteger( x )")
write( "{")
write( "  var l = x.length;")
write( "  if ( l == 0 ) return -1;")
write( "  for ( var k = 0; k < l; k++ )")
write( "  {")
write( "    var dig = x.charAt( k );")
write( "    if ( dig < \"0\" || dig > \"9\" )")
write( "    {")
write( "      return -1;")
write( "    }")
write( "  }")
write( "  return parseInt(x);")
write( "}")

write( "function isValidDate( m, d, y )")
write( "{")
write( "  m = isPosInteger( m );")
write( "  if ( m == -1 ) return false;")
write( "  d = isPosInteger( d );")
write( "  if ( d == -1 ) return false;")
write( "  y = isPosInteger( y );")
write( "  if ( y == -1 ) return false;")

write( "  if ( m < 1 || m > 12 ) return false;")
write( "  if ( y < 1900 && y > 100 ) return false;")
write( "  if ( d < 1 || d > daysInMonth( m, y ) ) return false;")
write( "  return true;")
write( "}")

write( "function isDateString( s )")
write( "{")
write( "  var ix = s.indexOf( \"/\", 0 );")
write( "  if ( ix != -1 )")
write( "  {")
write( "    var month = s.substring( 0, ix );")
write( "    s = s.substring( ix + 1, s.length );")
write( "    ix = s.indexOf( \"/\", 0 );")
write( "    if ( ix != -1 )")
write( "    {")
write( "      var day = s.substring( 0, ix );")
write( "      var year = s.substring( ix + 1, s.length );")
write( "      if ( isValidDate( month, day, year ) )")
write( "      {")
write( "        var date = \"\";")
write( "        date += parseInt(month) + \"/\";")
write( "        date += parseInt(day) + \"/\";")
write( "        date += parseInt(year);")
write( "        return date;")
write( "      }")
write( "    }")
write( "  }")
write( "  return \"\"")
write( "}")
write( "</script>")
}




