// application: Job Listings Center        
//     version: 1.0a (alpha of 7/22/96)   
//    fileName: Image.js             
// description: Functions defining images and buttons.   
//              The idea is to consolidate all image information in one place.  This is it.      
//              If an image's size is known in advance, it can be displayed faster.
//              A table in this file provides the following infor about images used in the system:
//                 name:  image name as used in the system.  Is root of several variable identifiers.
//                 width: width reserved for image
//                 height: expected height of image
//                 altText: what to display is image not (yet) found.
//                 onMouseOverMessage: what to display in the status bar on a mouse over if
//                                     image is used in a button.
//                 href: default href is image is used as a link.
//     company: Austin-Hayne Corporation.  (415) 655-3800                    
//              2000 Alameda de las Pulgas, Suite 242, San Mateo, CA 94403  
//     history: Created by ggh.  Released 7/22/96                          
//---------------------------------------------------------------------------------------------





/*-----------------------------------------------------------
  button creates a button (Link object) based on an image name.
  Will use button-creation defaults associated with image,
  unless overridded by input parameters.
  -----------------------------------------------------------*/

function button(name, mouseMessage, href){ 
  var command=""; 
  if (mouseMessage==null || mouseMessage==""){mouseMessage=eval("project."+name+"ImageMouse"  )};
  if (mouseMessage==null || mouseMessage==""){mouseMessage=eval("project."+name+"ImageAltText")};
  if (        href==null ||         href==""){        href=eval("project."+name+"ImageHref"   )};
  command = "<A href="+Q+href+Q
                  +" onMouseOver="+Q+"window.status="+SQ+mouseMessage+SQ+"; return true"+Q
                +">"
                    +eval("project."+name+"Image")
                +"</A>";
  return command;
};



/*-----------------------------------------------------------
  makeImg is used to create an Image object (the HTML for an
  image) based on input parameters.
  -----------------------------------------------------------*/

function makeImg(name, width, height, altText, mouseMessage, href){  
          var dimensions= (width>0 && height>0) ? ' width='+width+' height='+height+' ' : ''; 
          var command ="";
          command ="project." + name + "ImageAltText=" + Q  +altText + Q;  
          eval(command);                                                   
          command ="project."+name+"ImageHref="+Q+href+Q;                  
          eval(command);                                                   
          command="project."+name+"ImageMouse="+Q+mouseMessage+Q;          
          eval(command);                                                   
          command="project."+name+"Image="+Q+"<IMG SRC="+project.pathToImages+name.toLowerCase()+".gif border=0"
                                            + dimensions
                                            +" alt="+ SQ+altText+SQ
                                       +">"+Q;                           
          eval(command);                                                   
};



/*-----------------------------------------------------------
  setUpButtons is used to initialize various images and buttons
  used by the application.  The idea is to consolidate all
  information about images in one place -- the 'table' in this
  function.  Note: not all images are used as buttons, so the
  last two columns of the table are often not used.  Also, the
  last two columns are only defaults.
  -----------------------------------------------------------*/

function setUpButtons(){              // not all images are used as buttons, so last 2 cols may not apply

       //  NAME/FILE   WIDTH HT  ALT-TEXT         SHOW onMouseOver                          HREF
       //  ------       ---  --  --------    ----------------------------       --------------------------

  makeImg("Add"       ,130, 39, "Add  "   ,  "Add new job."                    ,  null);
  makeImg("Apply"     ,130, 39, "Apply"   ,  "Apply for this job."             ,  null);
  makeImg("Back"      ,130, 39, "Back"    ,  "Return to previous web page."    , "javascript:history.back()");
  makeImg("Bonus"     , 47, 28, "Reward"  ,  ""                                , "");
  makeImg("Button"    , 18, 13, "Go"      ,  "Run"                             , null); 
  makeImg("Cancel"    ,130, 39, "Cancel"  ,  "Cancel this operation and restore values" 
                                                                               , "javascript:history.back()");
  makeImg("Contact"   ,130, 39, "Contact" ,  "Contact applicant by e-mail."    ,  null);
  makeImg("Continue"  ,130, 39, "Continue",  "Continue"                        , "javascript:history.go(-2)");
  makeImg("Copy"      ,130, 39, "Copy"    ,  "Copy this Job"                   ,  null);
  makeImg("Delete"    ,130, 39, "Delete"  ,  "Delete this record"              ,  null);
  makeImg("Edit"      ,130, 39, "Edit"    ,  "Edit this Job"                   ,  null);
  makeImg("Free"      , 80, 48, ""        ,  ""                                , "");
  makeImg("Header"    ,590,  8,  ""       ,  ""                                , "");


  makeImg("HAppByContent",
                       477, 59,  "Keyword",  ""                                , "");   
  makeImg("HAppDetail",477, 59,  "App Details",  ""                            , "");    
  makeImg("HAppQuery" ,477, 59,  "App Query"  ,  ""                                , "");     
  makeImg("HJobAdd"   ,477, 59,  "Add Job"    ,  ""                                , "");     
  makeImg("HJobApply" ,477, 59,  "Apply"      ,  ""                                , "");     
  makeImg("HJobDetail",477, 59,  "Job Detail" ,  ""                                , "");     
  makeImg("HJobEdit"  ,477, 59,  "Edit Job"   ,  ""                                , "");     
  makeImg("HDefault"  ,477, 59,  "Job Center Home Page" ,  ""                      , "");     
  makeImg("HJobQuery" ,477, 59,  "Job Query"  ,  ""                                , "");     

  makeImg("HiringMgr" ,166, 49, "Mgr"         ,  ""                                , "");
  makeImg("HRMgr"     ,166, 49, "HRMgr"       ,  ""                                , "");

  makeImg("Home"      ,130, 39, "Go Home" ,  "Return to Job Center Home Page." , "default.html");
  makeImg("ItsBonus"  , 80, 48, "Reward"  ,  ""                                , "");
  makeImg("ItsNew"    , 80, 48, "New"     ,  ""                                , "");
  makeImg("KeyWord"   ,130, 39, "Key Word",  "Use alternative search criteria.", "appbycontext.html");
  makeImg("New"       , 47, 28, "New"     ,  ""                                , "");
  makeImg("None"      ,  1,  1, ""        ,  ""                                , "");
  makeImg("Reset"     ,130, 39, "Reset"   ,  "Reset fields to initial values." , "");
  makeImg("Seeker"    ,166, 49, "Seeker"  ,  ""                                , "");
  makeImg("Save"      ,130, 39, "Save "   ,  "Save data to database."          , "");
  makeImg("Submit"    ,130, 39, "Submit"  ,  "Submit this form for processing.", "");
  makeImg("SubmitApp" ,130, 39, "Submit"  ,  "Submit this Application."        , "");
  makeImg("TryIt"     , 80, 48, "Try It!" ,  ""                                , "");


  project.buttonBack = button("Back", null, null);

  project.buttonHome = button("Home", null, null);


};
